package hpdos_rdma_offloaded.rdma_protocol;

import java.io.IOException;
import java.nio.ByteBuffer;

import com.ibm.darpc.DaRPCMessage;

public class Request implements DaRPCMessage{
    public int operationType;
    public String key;
    public String value;
    private int SERIALIZED_SIZE = 256;
    private static char[] dst = new char[100];
    @Override
    public int write(ByteBuffer buffer) throws IOException {
        buffer.putInt(operationType);
        buffer.asCharBuffer().put(key + ";" + value + ";");
        return SERIALIZED_SIZE;
    }

    @Override
    public void update(ByteBuffer buffer) throws IOException {
        operationType = buffer.getInt();
        buffer.asCharBuffer().get(dst, 0, 99);
        String s = new String(dst);
        s = s.trim();
        String split[] = s.split(";");
        key = split[0];
        value = split[1];
    }

    @Override
    public int size() {
        
        return SERIALIZED_SIZE;
    }
    
    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public int getOperationType() {
        return operationType;
    }

    public void setOperationType(int operationType) {
        this.operationType = operationType;
    }

}
